% % Add user-defined preamble here.
% % Example: listing style or acronyms

%\lstdefinestyle{numbers}{
%	numbers=right,
%	stepnumber=1,
%	numberstyle=\tiny\color{magenta},
%	numbersep=-7pt
%}

\begin{acronym}
	\acro{abac}[ABAC]{Attribute Based Access Control}
	\acro{adp}[ADP]{Administration and Delegation Profile}
	\acro{alfa}[ALFA]{Abbreviated Language For Authorization}
	\acro{ar}[AR]{Attribute Retriever}
	\acro{at}[AT]{Attribute Table}
	\acro{ch}[CH]{Context Handler}
	\acro{ciso}[CISO]{Chief Information Security Officer}
	\acro{dac}[DAC]{Discretionary Access Control}
	\acro{drm}[DRM]{Digital Rights Management}
	\acro{ds}[DS]{Data Subject}
	\acro{gdpr}[GDPR]{General Data Protection Regulation}
	\acro{iam}[IAM]{Identity and Access Management}
	\acro{ict}[ICT]{Information and Communication Technology}
	\acro{iot}[IoT]{Internet of Things}
	\acro{json}[JSON]{JavaScript Object Notation}
	\acro{mac}[MAC]{Mandatory Access Control}
	\acro{mdp}[MDP]{Multiple Decision Profile}
	\acro{mfa}[MFA]{Multi-Factor Authentication}
	\acro{msgbus}[MSG BUS]{Message Bus}
	\acro{om}[OM]{Obligation Manager}
	\acro{opa}[OPA]{Open Policy Language}
	\acro{pap}[PAP]{Policy Administration Point}
	\acro{pdp}[PDP]{Policy Decision Point}
	\acro{pep}[PEP]{Policy Enforcement Point}
	\acro{pip}[PIP]{Policy Information Point}
	\acro{rbac}[RBAC]{Role Based Access Control}
	\acro{siuv}[SIUV]{Smart-car Identity management and Usage control system based on Verifiable credentials}
	\acro{sm}[SM]{Session Manager}
	\acro{tlee}[TLEE]{Trust Level Evaluation Engine}
	\acro{ucon}[UCON]{Usage Control}
	\acro{ucsp}[UCS+]{Usage Control System Plus}
	\acrodefplural{ucsp}[UCS+ nodes]{Usage Control System Plus nodes}
	\acro{xacml}[XACML]{eXtensible Access Control Markup Language}
	\acro{zta}[ZTA]{Zero-Trust Architecture}
	\acro{api}[API]{Application Programming Interface}
\end{acronym}

\lstdefinestyle{numbers}{
	numbers=right,
	stepnumber=1,
	numberstyle=\tiny\color{magenta},
	numbersep=-7pt
}

\lstdefinestyle{MyFrame}{
	basicstyle={\scriptsize},
	backgroundcolor=\color{gray!10},
	xleftmargin=0.5em,
	xrightmargin=0.5em,
	framexrightmargin=0.5em,
	frame=shadowbox,
	frame=single,
	breaklines=true,
	linewidth=\linewidth,
	postbreak=\raisebox{0ex}[0ex][0ex]{\ensuremath{\color{blue}\hookrightarrow\space}},
	columns=fullflexible,
	captionpos=t,
	tabsize=4,
	showstringspaces=false,
	breakatwhitespace=false,
}

\lstset{
	style=numbers,
	style=MyFrame,
	escapechar={|},
	stringstyle=\color{gray},
	identifierstyle=\color{black},
	keywordstyle=\color{blue},
	upquote=true,
	morekeywords={policy, target, clause, rule, condition, on, permit, obligation, Attributes, in, If, Else, Then},
}

\colorlet{punct}{red!60!black}
\definecolor{background}{HTML}{EEEEEE}
\definecolor{delim}{RGB}{20,105,176}
\colorlet{numb}{magenta!60!black}

\lstdefinelanguage{json}{
	numbers=right,
	stepnumber=1,
	numbersep=0pt,
	showstringspaces=false,
	breaklines=true,
	frame=single,
	framexrightmargin=0.5em,
	upquote=true,
	keywordstyle=\color{blue},
	morekeywords={@context, credentialSubject, id, issuanceDate, issuer, type},
	literate=
	{:}{{{\color{punct}{:}}}}{1}
	{,}{{{\color{punct}{,}}}}{1}
	{\{}{{{\color{delim}{\{}}}}{1}
	{\}}{{{\color{delim}{\}}}}}{1}
	{[}{{{\color{delim}{[}}}}{1}
	{]}{{{\color{delim}{]}}}}{1},
}

\titlerunning{UCON+}